/* eslint prefer-rest-params: 0 */

import invariant from 'invariant';
import { Observable } from 'rxjs';
import isObservable from 'fluorine-lib/lib/util/isObservable';

export default function combineStores(stores) {
  invariant(typeof stores === 'object', 'combineStores: `stores` is expected to be an object containing Observables.');

  var keys = Object.keys(stores);

  function reduceStates() {
    var size = arguments.length;
    var state = {};

    for (var index = 0; index < size; index++) {
      var key = keys[index];
      state[key] = arguments[index];
    }

    return state;
  }

  return Observable.combineLatest.apply(Observable, keys.map(function (key) {
    var store = stores[key];

    invariant(isObservable(store), 'combineStores: `stores` is expected to contain Observables only.');

    return store;
  }).concat([reduceStates]));
}